;----------------------------------------------------------
;    
;   
;       Flo, Fhi, Fhihi

EraseBlock:

	lds temp, Command+4	;   
	cpi temp, _Intel
	je EraseIntel
	cpi temp, _SST
	je EraseSST
	ret	;   
EraseIntel:	
	lds Flo,(Command+1)
	lds Fhi,(Command+2)
	lds Fhihi,(Command+3)	;  c 

	lds temp, Command+5	;   , ?

	cpi temp,_First		;   
	jne NotReqVccOn		;  ,    
	rcall SafeOn
	
NotReqVccOn:	
	BusToWrite	; 
	ldi data, _BlockErase1
	rcall WriteFWH	;  
	ldi data, _BlockErase2
	rcall WriteFWH	;  
	
	ldi temp, 10
	mov R0, temp	;    10   1 
	
WaitWSMReady:		;   Write State Machine FWH

	ldi temp,100
	rcall Pause10MS	;  
	
	rcall ReadWSMstatus
	mov data,temp	;  
	rol temp
	jc EndWaitWSM	; WSM  
	
	dec R0
	jnz WaitWSMReady

EndWaitWSM:
	st Y+, data	;    WSM
	BusToWrite	; 
	ldi data, _ClearStatus
	rcall WriteFWH	;   "  "
	
	lds temp, Command+5	;   , ?
	cpi temp,_Last	;   ?
	jne NotReqVccOff	;  ,    
	rcall safeOFF
NotReqVccOff:		
ret
;-------------------------------------------------
EraseSST:
	lds Flo,(Command+1)
	lds Fhi,(Command+2)
	lds Fhihi,(Command+3)	;  c 

	lds temp, Command+5	;   , ?

	cpi temp,_FullErase	
	je FullErase		;  ,    
		
	ret	;   
FullErase:	
	rcall SafeOn
	
	BusToWrite	; 
	loadData 0x5555, 0xAA
	Rcall WriteFWH	;   " " (SST)

	loadData 0x2AAA, 0x55
	Rcall WriteFWH	;   " " (SST)

	loadData 0x5555, 0x80
	Rcall WriteFWH	;   " " (SST)

	loadData 0x5555, 0xAA
	Rcall WriteFWH	;   " " (SST)

	loadData 0x2AAA, 0x55
	Rcall WriteFWH	;   " " (SST)

	loadData 0x5555, 0x10
	Rcall WriteFWH	;   " " (SST)

	ldi temp, 10
	mov R1, temp	;    10   1 
	BusToRead		
WaitSSTready:		;   Write State Machine FWH
	ldi temp,100
	rcall Pause10MS	;  
	SetOElow		; FWH  
	nop
	in Data, InData		;   
	SetOEhigh		;   
	andi Data, 0x80		;  7 
	jnz SSTready
	dec R1			;  ,     
	jnz WaitSSTready
SSTready:
	st Y+, Data		;    WSM
;	lds temp, Command+5	;   , ?
;	cpi temp,_EndErase	;   ?
;	jne NotReqVccOff	;  ,    
	rcall safeOFF
ret