;-----------------------------------------------
;       FWH
;-----------------------------------------------

;----------------------------------------------
;  
;		      2 		 3 
.equ _SoftReset = 0xFF;	  - 		  -	   
.equ _ReadIdent	= 0x90; R VendorID	R DeviceID
.equ _ReadStatus= 0x70; R   -
.equ _ClearStatus=0x50;   - 		  -

;     
.equ _BlockErase1 =0x20;   w 0xD0 	  -	
.equ _BlockErase2 =0xD0;

;       
.equ _ByteWrite =0x40  ;   W 	  -

;----------------------------------
.macro 	BusToRead	;    
	clr temp
	out DirData, temp
	out OutData, temp
.endm
;----------------------------------
.macro 	BusToWrite	;    
	ser temp
	out DirData, temp
.endm

;-----------------------------------------------------------------
;  /  
;      
.macro loadData 
	ldi data, @1
	ldi flo, low(@0)
	ldi fhi, high(@0)
.endm
;----------------------------------------------------------
;     WriteFWH  ReadFWH
;        FWH.
;     / 
;    Flo, Fhi, Fhihi.
;      Data, c  Data

;----------------------------------------------------------
;  CE   (0), OE  (1)
WriteFWH:
	rcall SetA		;  
	out OutData, Data	;  
	SetWElow
	SetWEhigh		;    FWH	
ret
;----------------------------------------------------------
;  CE   (0), WE  (1)
ReadFWHwith4nop:
	rcall SetA		;  
	SetOElow		; FWH  
; qqq     RDY/Busy	
;    FWH  
	nop
	nop
	nop
	nop
	in Data, InData		;  
	SetOEhigh		;   
ret
;***********************************************************
;  FWH

;----------------------------------------------------------
;    State Machine FWH   
SoftReset:
	SetOEhigh
	ldi data, _SoftReset
	rcall WriteFWH	
ret

;**********************************************************
;       FWH:
; ReadIdent -   .
; ReadBlock -  
; WriteBlock -  
; EraseBlock - 
; /   RX/TX 
;          
;  
;**********************************************************

;-----------------------------------------------------------------
;    FWH  1
IncrementA:
	inc Flo
	jnz EndIncrementA
	inc fhi
	jnz EndIncrementA
	inc FhiHi	
EndIncrementA:
ret
;-----------------------------------------------------------------
;   FWH   
;   A[0..19]   A[0..10]
;    R
;    A[0..10],
;   A[11..19]  8mBit 18-4mBit 17-2mBit
; 
SetA:
	SetRChigh	;  R/C    

	out  OutAlo, Flo  ; A[0..7]
	mov temp, Fhi
	andi temp, 0x07	;  A[8..10]
	in Ahi, InAhi	;       
	andi Ahi,0xF8	;    A[8..10]
	or Ahi, temp	;  A[8..10]
	out OutAhi,Ahi  ;     
SetRow:	
	SetRClow	;  ROW
	
	mov temp,FhiHi  ; A[19..16]
	mov Alo,Fhi	; A[15..8]
	
	ror temp	; A16  
	ror Alo		; lo=[A16..9]
	
	ror temp	; A17  
	ror Alo		; lo=[A17..10]
	
	ror temp	; A18  
	ror Alo		; lo=[A18..11]
	
	out OutAlo, Alo ;  A[18..11]
	
;  / A19,    0
	
	cbi OutAHi, A8	;   
	cbi OutAHi, A9
	cbi OutAHi, A10	
	
	ror temp 	;    A19
	jnc SETCOL	; A19  0    column
	sbi OutAHi, A8  ;  A19
SETCOL:
	SetRCHigh	;  Column	
ret
;-----------------------------------------------------------------
;  ,    FWH
;     FWH   
SafeOn:
	InitPortCon	;   
			; TXD, CE,OE,VCCON,LED  , RXD, RDY/BUSY  
	InitPortAlo	;   A[0..7]   0
	InitPortD	;   D[0..7]   
	InitPortAhi	;   Ahi[8..10]  
	in temp,InCon
	andi temp,0x92   
	out OutCon, temp ;     FWH 0,  
	VCCon		;  
	ldi temp,25
	rcall Pause10MS ;       
	rcall SetA
	SetOEhigh
	SetWEhigh
	SetRCHigh
	SetRSTHigh
	ldi temp,10
	rcall Pause10MS ;   100ms
ret
;-----------------------------------------------------------------
;  ,    FWH
SafeOff:
	setRSTlow
;     0   pull-Up
	clr temp
	out OutAlo, temp
	out DirAlo, temp
	out OutAhi, temp
	out DirAhi, temp
	out DirData, temp
	out OutData, temp
	
	ldi temp, 0x92
	out DirCon,temp
	out OutCon,temp		;  , RXD  1.
	ldi temp, 25
	rcall Pause10MS		;     
ret
;-----------------------------------------------------------------
;   WSM Intel

ReadWSMstatus:
	BusToWrite	; 
	ldi data, _ReadStatus
	out OutData, Data
	SetWeLow
	SetWeHigh

	BusToRead	

	SetOElow		; FWH  
	nop
	in temp, InData		;   
	SetOEhigh		;   
ret
