;  
;     :
; Flo, Fhi, Fhihi   
; Data-  () 
; TypeProg   Intel  SST

WriteBlock:
	lds Flo,(Command+1)
	lds Fhi,(Command+2)
	lds Fhihi,(Command+3)	;  c 
	
	lds BigDataCounter, (Command+5)	;    16
	lds BigDataCounter2,(Command+6)    ;   16/128
	
	lds temp, (Command+4)	;  : Intel, SST
	cpi temp, 'I'
	je IntelWrite
	rjmp SSTWrite

IntelWrite:	
	lds temp, (Command+7) 
	cpi temp, _First
	jne SetStatusWrite
	rcall SafeOn
	
SetStatusWrite:
	ldi temp, Ok		;      
	sts (Answer+6), temp 
	
WaitBlockEntry:		;    
	rcall MakeNextPack	
	
WaitBlock:
	LedOFF
	mov temp,DataCounter
	cpi temp, 0
	jne WaitBlock 
	LedOn
;  

	loadX RX	; X -      
	
	ldi temp, 128	;      128 
	mov WriteBytesCounter, temp
	
	BusToWrite 
	SetOEHigh
	SetWEHigh

NextByteWrite:
	BusToWrite
	ld Data, X+
	cpi data, 0xFF
	je EndWaitoneByte

	ld Data, -X	;    
		
	ldi data, _ByteWrite
	rcall WriteFWH	; 

	ldi temp, 20	;  20  
	mov R0, temp

NotZero:
	ld Data, X+		
	rcall WriteFWH	; c 
WaitOneByte:	
	rcall ReadWSMstatus
;	mov data,temp	;  
	rol temp
	jc EndWaitoneByte	; WSM  
	dec R0
	jnz WaitOneByte		;  , 
	
	ldi temp, NotOk		;    State Machine
	sts (Answer+6), temp 
	
EndWaitoneByte:
	rcall IncrementA
	dec WriteBytesCounter
	jnz NextByteWrite
	sbiw BigDataCounter, 0x1
	jnz WaitBlockEntry	;   128 

ReturnToCommandmode:
;     
	lds temp, (Command+7) 
	cpi temp, _Last
	jne ReturnWithOutVccOFF
	rcall SafeOff
	
ReturnWithOutVccOFF:	

;   3  ,  WriteBlock,  
	LoadY Answer
	ldi temp, Ok
	st Y+, Temp 
	ldi temp, _WriteBlock
	st Y+, Temp 
	
	ldi temp, LastBlock
	st Y+, Temp 	
	
	rcall MakeAnswer;  
ret
;----------------------------------------------------------
SSTWrite:
	lds temp, (Command+7) 
	cpi temp, _First
	jne SST_SetStatusWrite
	rcall SafeOn
	
SST_SetStatusWrite:
	ldi temp, Ok		;      
	sts (Answer+6), temp 
	
SST_WaitBlockEntry:		;    
	rcall MakeNextPack	
	
SST_WaitBlock:
	LedOFF
	mov temp,DataCounter
	cpi temp, 0
	jne SST_WaitBlock 
	LedOn
;  

	loadX RX	; X -      
	
	ldi temp, 128	;      128 
	mov WriteBytesCounter, temp
	
	BusToWrite 
	SetOEHigh
	SetWEHigh

SST_NextByteWrite:
	BusToWrite
	ld Data, X+
	cpi data, 0xFF
	je SST_EndWaitoneByte

	ld Data, -X	;    
	
	BusToWrite	; 

	push Flo
	push FHi	;     
		
	LoadData 0x5555, 0xAA
	Rcall WriteFWH	;    (SST)
	
	LoadData 0x2AAA, 0x55
	Rcall WriteFWH	;    (SST)

	LoadData 0x5555, 0xA0
	Rcall WriteFWH	;    (SST)

	pop Fhi
	pop Flo	;     

SST_NotZero:
	ld Data, X+		
	mov R1, Data	;  
	
	rcall WriteFWH	; c 

	ldi temp, 40	;  40 
	mov R0, temp
	
	BusToRead
	
SST_WaitOneByte:
	rcall SetA	;   2 
	in Data, InData
	eor Data, R1
	andi Data, 0x80	;   7
	jz SST_EndWaitoneByte
	
	dec R0
	jnz SST_WaitOneByte		;  , 
	
	ldi temp, NotOk		;    State Machine
	sts (Answer+6), temp 
	
SST_EndWaitoneByte:
	rcall IncrementA
	dec WriteBytesCounter
	jnz SST_NextByteWrite
	sbiw BigDataCounter, 0x1
	jnz SST_WaitBlockEntry	;   128 
        rjmp ReturnToCommandmode ;   
ret
;-------------------------------------------------
;      
;  R0
MakeNextPack:
;      
	ldi temp, Dmode	
	sts mode, temp	;  
	
	loadX RX	; X -     
	ldi temp, 0x80	;  128 
	mov DataCounter, temp
		
;  

	LoadY Answer
	ldi temp,OK	;   ,    
	st y+,temp	
	
	ldi temp, _WriteBlock	;  WriteBlock  :-),   
	st y+,temp
	
	lds temp, command+5
	st y+,temp

	lds temp, command+6
	st y+,temp

	lds temp, 0x11
	st y+,temp
	
	LoadY Answer	
	ldi temp, 8	;  
	mov R0, temp
CycleNextPack:
	sbi usr, txc	;    
	ld temp, Y+ 
	out UDR, temp	
WaitNextPack:	
	sbis usr, txc		;    
	rjmp WaitNextPack	;  , 
	dec r0
	jnz CycleNextPack
ret	
;-------------------------------------------------
