;-------------------------
;   
;    (HAL  "")
;
;      , 
;      Intl
;  BREQ  JZ
;-------------------------

.EQU TopStack =ramend	; ramend   8515def.inc 
.equ RamBegin = 0x60	;   

.def Data =r16	;   / FWH ( 32..39)PORTA
.def Alo  =r17	;  [0..7]  FWH  ( 21..28)PORTC 
.def Ahi  =r18	;  [8..10],rst,r/c  FWH( 1..8) PORTB 
.def temp =r19	;

;Port A pins
.equ OutData = PORTA
.equ InData =  PINA
.equ DirData = DDRA

;Port B pins
.equ outAhi = PORTB
.equ InAhi = PINB
.equ DirAhi = DDRB


.equ A8 =0	;    
.equ A9 =1
.equ A10 =2

.equ rst = 3 ; rst FWH, pin3, 
.equ rc  = 4 ; R/C FWH  pin4, 

;Port C pins
.equ OutAlo = PORTC
.equ DirAlo = DDRC

;Port D pins
.equ OutCon = PORTD
.equ InCon  = PinD
.equ DirCon = DDRD

.equ	RDY = 2 ; RDY/BUSY# FWH   
.equ	LED = 4 ; LED FWH         , 0 - 

.equ	WE  =  5 ; WE FWH          
.equ	OE  =  6 ; OE FWH          
.equ	VCCpin= 7 ;  VCC FWH  ,  0

;    ,    
;     .
;     (  )
;        .
;    :-)

;---------------------------------
.macro SetRSThigh
	sbi OutAhi, rst	; Reset  FWH  
.endm
;---------------------------------
.macro SetRSTlow
	cbi OutAhi, rst	; Reset  FWH 
.endm
;---------------------------------
.macro SetRChigh
	sbi OutAhi, rc	; ROW/COL=high   
.endm
;---------------------------------
.macro SetRClow
	cbi OutAhi, rc	; ROW/COL=Low   
.endm
;---------------------------------
.macro LEDon
	cbi OutCon, LED	;  
.endm
;---------------------------------
.macro LEDoff
	sbi OutCon, LED	;  
.endm
;---------------------------------
.macro SetCElow
	cbi OutCon, CE	;
.endm
;---------------------------------
.macro SetOElow
	cbi OutCon, OE	;
.endm
;---------------------------------
.macro SetCEhigh
	sbi OutCon, CE	;
.endm
;---------------------------------
.macro SetOEhigh
	sbi OutCon, OE	;
.endm
;---------------------------------
.macro SetWEhigh
	sbi OutCon, WE	;
.endm
;---------------------------------
.macro SetWElow
	cbi OutCon, WE	;
.endm
;---------------------------------
.macro VCCoff
	sbi OutCon, VCCpin	;
.endm
;---------------------------------
.macro VCCon
	cbi OutCon, VCCpin	;
.endm
;---------------------------------
.macro 	InitPortCon	;   
	ldi temp,0xFA   	; TXD,CE,OE,WE,VCCON,LED  , RXD, RDY/BUSY  
	out DirCon, temp
	ldi temp, 0xFB	; RXD PULL-UP
	out OutCon, temp
.endm
;---------------------------------
.macro 	InitPortAlo	;   A[0..7]
	ldi temp,0xFF   ;   , Pull-up 
	out DirAlo, temp
	clr temp
	out OutAlo, temp
.endm
;---------------------------------
.macro 	InitPortD	;   DATA[0..7]
	clr Data
	out DirDATA, Data ; DATA[0..7]  
	out OutDATA, Data ; pull-up  
.endm
;---------------------------------
.macro 	InitPortAhi	;   Ahi[8..10]  
	ldi temp, 0x1F  ;
	out DirAhi, temp ; DATA[8..10],RST,RC  ,   
	clr Ahi
	out OutAhi, Ahi ; pull-up  
.endm
;---------------------------------
.macro LoadX
	ldi R27, high(@0)
	ldi R26, low(@0)
.endm
;-----------------------
.macro LoadY
	ldi R29, high(@0)
	ldi R28, low(@0)
.endm
;----------------------------------
;.macro LoadZ
;	ldi R31, high(@0)
;	ldi R30, low(@0)
;.endm
;---------------------------------

;###############################################3
;        I8051
;    I8086/80286/80386/80486/PI/PII/PIII/PIV

;---------------------------------
.macro 	JNZ	;  
	BRNE @0
.endm
;---------------------------------
.macro 	JNE	;  
	BRNE @0
.endm
;---------------------------------
.macro 	JZ	; 
	BREQ @0
.endm
;---------------------------------
.macro 	JE	; 
	BREQ @0
.endm
;---------------------------------
.macro 	JC	; 
	BRCS @0
.endm
;---------------------------------
.macro 	JNC	;  
	BRCC @0
.endm
;---------------------------------
.macro 	JGE	;   
	BRGE @0
.endm
;---------------------------------
