;     
; Intel FWH   
;  AT90S8515
;  Atmel AVR Studio 3.55
; () misyachniy@mail.ru 22.03.2003
;   InfoSoft    .

.nolist
.include "8515def.inc"
.include "macro.inc"
.list
.listmac

;     ""

; R0    
; R0  R1         FWH


.def	WriteBytesCounter=R3	;   .
.def	DataCounter=R4		;   .

;R16..R19   "macro.inc"

.def    rxtemp=R20	;     UART RX

; r23..24   FWH. ,  FWH  
.def	flo=R21		; A[0..7]
.def	fhi=R22		; A[8..15]
.def	fhihi=R23	; A[16..19]

;R25:R24	;  /  
.def	BigDataCounter=R24
.def	BigDataCounter2=R25

; X (R27:R26)     
;      /
;          FWH

;  (R29:R28)       

; Z (R31:R30) 


.dseg 
RX	: .byte 256	;   
Command	: .byte 8	;     
	;+0  
	;+1   A[7..0]
	;+2   A[15..8]
	;+3   A[19..16]
	
	;+4,5,6  
	; +7  ,   CRC  /
	
Answer	: .byte 8	;     
mode	: .byte 1	;    
	.equ	Cmode	=0	;   
	.equ	Dmode   =1	;  
RxBytes : .byte 1	;   

;****Source code***************************************************
;    .
; -     :-)))
;    ()   
;    115,200, 8 , 1 ,  .
;   ,      CRC8.
;      :
; 1)  .
; 2)  .
;
;     2 
; 1.1    8 
; 1.2    8 
;        ( )  
;    ( )   (FWH    )

;  .
;    (256 )     
; 2.1       / (8 )
;           ()  .
; 2.2    8     
; 2.3        
;            
;        FWH m 

;       

;  
.equ	OK 		= 0;

.equ	NextBlock	= 1;	;   
.equ	LastBlock	= 2;	;   
.equ	ErrBlock	= 99;	;   ,   CRC

.equ	NotOk		= 0xFE	;   
.equ    FWHnotReady	= 0xFD	; FWH   


;  

.equ	_empty	   =0x11	;  
.equ	_Ident	   =0x22	;   
.equ	_ReadBlock  =0x33	;  
.equ	_WriteBlock =0x44	;  
	.equ	_First=0x1 	;   
	.equ	_Last =0x2	;   
.equ	_EraseBlock =0x55	;  
	.equ	_FullErase =0x3  ;   .  SST	
	
.equ	_reset	   =0x99	;  

.equ	_Intel	='I'	;   Intel  
.equ	_SST	='S'	;   SST  

.equ	MinBlock = 0x40	;     4000h=16 ;

.cseg			;CODE segment
.org 0
	rjmp EntryProg	;  
	reti 		; INT0
	reti		; INT1
	reti		; Timer Capture Event
	reti		; Timer Counter MATCH A
	reti		; Timer Counter MATCH B
	reti		; Timer Counter 1 overflow
	reti		; Timer Counter 0 overflow
	reti		; SPI, STC
	rjmp UARTrx	; UART RX Complete
	reti		; UART DATA REGISTR 
	reti		; UART TX Complete
	reti		; Analog Comparator
	
;*** Reset handler **************************************************
EntryProg:	
	cli			;disable global interrupts 

	sbi ACSR,ACD		;shut down comparator to save power
	
	ldi temp,high(TopStack)
	out SPH, temp
	ldi temp,low(TopStack)
	out SPL, temp            ; init Stack 
	
main:	
	InitPortCon	;   
			; TXD, CE,OE,VCCON,LED  , RXD, RDY/BUSY  
	InitPortAlo	;   A[0..7]   0
	InitPortD	;   D[0..7]   
	InitPortAhi	;   Ahi[8..10]  
	in temp, inCon
	andi temp,0x92   
	out OutCon, temp ;     FWH 0,  

;  UART
	ldi temp,1
	out UBRR,temp	;  3,6864   115,200 
	ldi temp,0b10011000
	out ucr,temp    ;   ,   8 
			;    
			
	cbi usr, rxc	;       
	sbi usr, txc	;     

	ldi temp, Cmode	
	sts mode, temp	;  
	
	ldi temp, 8
	sts RxBytes, temp;   

	loadX command	; X -    
	
	ldi temp, 0xA5
	out UDR, temp	; 
		
;  UART					
	loadY Answer
	ldi temp,0x77
	mov R0, temp
	ldi temp, 9
	
ResetAnswer:
	st y+, R0
	dec temp
	jnz ResetAnswer
	sei		;  ,  
	
MainCycle:

LedOn
	ldi temp, 10
	rcall Pause10MS
Ledoff
	ldi temp, 10
	rcall Pause10MS

;      
;    

;         

	lds temp, RxBytes
	
	cpi temp,8
	je MainCycle	;  

LEDS:	
LedOff
	lds temp, RxBytes
	cpi temp,0
	jne LEDS	;   
	
;   
	
	lds temp, Command
	cpi temp, _reset
	 je ExecReset
	cpi temp, _empty
	 je ExecEmpty
	cpi temp, _Ident
	 je ExecIdent
	cpi temp, _ReadBlock
	 je ExecReadBlock
	cpi temp, _WriteBlock
	 jne Not_WriteBlock
	 rjmp ExecWriteBlock
	 
Not_WriteBlock:
	cpi temp, _EraseBlock
	 jne Not_EraseBlock
	 rjmp ExecEraseBlock
	 
Not_EraseBlock:
	 
BadCommand:
	ldi temp,NotOk	;  
	LoadY Answer
	st Y+, Temp 
	lds temp, command
	st Y+, Temp 	;   
	rcall MakeAnswer;  
	rjmp MainCycle   ;    
	
ExecReset:
	Vccon
	loadY Answer
	
	ldi temp, Ok
	st Y+, temp

	ldi temp, _Reset
	st Y+, temp

	rcall makeAnswer
	rjmp MainCycle
	
ExecEmpty:
	VccOff
	loadY Answer
	
	ldi temp, Ok
	st Y+, temp

	ldi temp, _Empty
	st Y+, temp
	
	rcall makeAnswer
	rjmp MainCycle
	
ExecIdent:
	LoadY Answer
	ldi temp, Ok	;  
	st y+, temp	
	ldi temp, _Ident ;    
	st y+, temp	
	
	rcall ReadIdent	;  
	rcall makeAnswer
	rjmp MainCycle
	
ExecWriteBlock:
	rcall WriteBlock
	rjmp MainCycle
ExecEraseBlock:
	LoadY Answer
	ldi temp, Ok	;  
	st y+, temp	
	ldi temp, _EraseBlock ;    
	st y+, temp

	rcall EraseBlock	;  
	
	rcall makeAnswer	;  	
	rjmp MainCycle
	
ExecReadBlock:	
	LoadY Answer
	ldi temp, Ok	;  
	st y+, temp	
	ldi temp, _ReadBlock ;    
	st y+, temp
	
; rcall makeAnswer	;   ReadBlock.inc
			
;      
	
	rcall ReadBlock
	rjmp MainCycle
	
;---------------------------------------------------------
;     
;     
;  R0
makeAnswer:
;     
	ldi temp, Cmode	
	sts mode, temp	;  
	
	ldi temp,8
	sts RxBytes, temp;   

	loadX command	; X -    
;  

	LoadY Answer	;    
	ldi temp, 8	;  
	mov R0, temp
CycleAnswer:
	sbi usr, txc	;    
	ld temp, Y+ 
	out UDR, temp	
WaitAnswer:	
	sbis usr, txc	;    
	rjmp WaitAnswer	;  , 
	dec r0
	jnz CycleAnswer
ret	

;****Interrupt service routine***************************************
UARTrx:	
	in rxtemp, SREG
	push rxtemp
	in rxtemp, USR
	andi rxtemp, 0x10	; Frame Error
	jz NoFrameError
	Vccon
	
NoFrameError:

	lds rxtemp, mode	;    ?
	cpi rxtemp, Dmode
	jne CmodeExec		;    

;  
; X   

DmodeExec:	
	mov rxtemp, DataCounter
	cpi rxtemp,0
	in rxtemp, UDR		;      
	
	je EndRxISR 	;   , 
;RX
	dec DataCounter		;     
	st X+, rxtemp		;  
	rjmp EndRxISR 		;  

CmodeExec:	;  

	lds rxtemp, RXbytes
	cpi rxtemp, 0	;  
	je ErrorRX	;   
	
	dec rxtemp
	sts RXbytes, rxtemp ;     
	
	in rxtemp, UDR	;  	

	st X+, rxtemp		;  
	rjmp EndRxISR
	
ErrorRX:
	ledON
	rjmp ErrorRX
	
EndRxISR:	
	pop rxtemp
	out SREG, rxtemp
	reti			;
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
.nolist
.include "pauses.inc"
.include "FWH.inc"
.include "ReadBlock.inc"
.include "ReadIdent.inc"
.include "EraseBlock.inc"
.include "WriteBlock.inc"
